/* File: get_route.c
 * print route information out of routing table 
 */

#include <stdio.h>
#include <sys/un.h>
#include <sys/types.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "header.h"
#include "proto.h"

#define	 BBAS	690	/* backbone AS */

int 
get_route(rcphost, port_num, wl)
	char 	*rcphost;
	int	port_num;
	int	wl;
{
	/* global declarations   */
	extern 	int ConnectTo(); 	/* connect to host */
	extern	int readn();		/* make sure n bytes are read */
	extern	int masklen();		/* (mask) prefix length */
	extern 	char *trim_zero();	/* get dest. prefix */

	/* gated structure, not compatible w/ sockaddr_in */
	struct sockaddr_in_new {	
        	byte    sin_len;
        	byte    sin_family;
        	u_int16 sin_port;
        	struct 	in_addr sin_addr;
	} *ptr;	

	rt_head_proto	rt_blk;

	int 	count, blkcount = 0;
	char 	c = PT_DUMPBIN;
	int	sock;
	int	i;

	/* connect to a host (port) */
	if ((sock = ConnectTo(rcphost, port_num)) < 0)	
		return(NO_RCP_CONNECTION);

	write(sock, &c, sizeof(c));	/* lpj's protocol */

	printf("*** Start to read routing table\n");

	/* Loop, reading until the data stream ceases.  */
	for (;;) {
		/* make sure the structure is clean */
		/* bzero((char *) &rt_blk, sizeof(rt_blk));
  		 */

  		if ((count = readn(sock, (char *)&rt_blk, sizeof(rt_blk))) < 0) {
			perror("error in reading\n");
			exit(1);
		}
/*
{ int ff, gg; for(ff = 0; ff < sizeof(rt_blk);) {
	if ((ff % 20) == 0) printf("\n");
	for(gg = 0; gg < 20; gg++, ff++)
	    printf("%02X ", (unsigned int)(((unsigned char *)(&rt_blk))[ff]));
} printf("\n");}

		printf("sizeof(rt_blk): %d\n", sizeof(rt_blk));
		printf("count: %d\n", count);
 */

		if (count == 0) break;
		else if (count != sizeof(rt_blk))
	      		return(BAD_RCP_DATA);
  
  		blkcount++;

/*
		if (blkcount > 80) break;
		printf("blk: %d: ", blkcount);
 */
 

  		ptr = (struct sockaddr_in_new *) & (rt_blk.rtp_dest.in);

		/* note that function inet_ntoa() is evaluated before
		 * doing printf. If there are two inet_ntoa() calls in
 		 * one printf, one will be overwritten by another as
		 * inet_ntoa() returns a static pointer
		 */
/*
		printf("%s - ", 
			inet_ntoa(rt_blk.rtp_dest.in.sin_addr));

		printf("%s;",
			inet_ntoa(rt_blk.rtp_dest_mask.in.sin_addr));
 */



		i = mask_len(rt_blk.rtp_dest_mask.in.sin_addr.s_addr);
		
		if (wl == 1) {	/* print full path information */
			printf("%s/%d\t", 
				trim_zero(rt_blk.rtp_dest.in.sin_addr, i), i);

			for (i = 0; (i < rt_blk.rtp_aspathlen) &&
					(i < RTP_MAXAS); i++)
					printf("%d ", rt_blk.rtp_aspath[i]);
			printf("\n");
		}
		else	{
			if ((rt_blk.rtp_aspathlen > 0) &&
					(rt_blk.rtp_aspath[0] == BBAS)) {
				printf("%s/%d\t", 
					trim_zero(rt_blk.rtp_dest.in.sin_addr, i), i); 
				printf("%d\n", rt_blk.rtp_aspath[1]);
			}
		}	
  	}	/* for loop */

	close(sock);

	printf("*** blkcount: %d\n", blkcount);		
        printf("*** Done with data dump \n");
	printf("*** Connection to %s closed\n",rcphost);

        return (0);
}


/* 
 * Read "n" bytes from a descriptor. Use in place of
 * read() when fd is a stream socket.
 */

int
readn(fd, ptr, nbytes)
	register int	fd;
	register char	*ptr;
	register int	nbytes;
{
	int	nleft, nread;

	nleft = nbytes;
	while (nleft > 0) {
		nread = read(fd, ptr, nleft);
		if (nread < 0)	return nread;	/* err: return < 0 */
		else if ((nread == 0) || ((nread == 1) &&
				(*ptr == PT_ENDDUMP))) {
			nbytes = nleft; 
			break;			/* EOF */
		}
		
		nleft -= nread;
		ptr   += nread;
	}

	return (nbytes - nleft);		/* return >= 0 */
}



	

