/* This is the main program of the offnet project        */
/* The command to run is : Runoffnet -h host -p port     */
/* where host and port specify where to get the binary   */
/* dump, and they are optinal (the defaults are:         */
/* host: 140.222.51.1, port: 145).                       */


#include "header.h"

void main (argc, argv)
   int argc;
   char *argv[];
{
	extern int get_route();

        extern  int optind, opterr;     /* for getopt() routine */
        extern  char *optarg;           /* .... */

        char *Usage = "Usage: dumproute [-d] [-h] [-w] [-r router_addr] [-p port]\n\n";
        char *optstr = "r:p:dhw";        /* options of command line */

        int 	c, rc;
	int	port_number = TCP_PORT;	/* port number */
	char	rcp_host[30];		/* host address */
	int	w_level = 0;		/* write level: 0 - only AS annou. to 690;
					 * 	       1 - all AS path */	

	strcpy(rcp_host, RCP_HOST);
	
	/* process the options */
        while((c = getopt(argc, argv, optstr)) != EOF)
                switch(c) {
                case 'd':
                        /* need further work */
                        break;
                case 'r': strcpy(rcp_host, optarg);	break;
                case 'p': port_number = atoi(optarg);	break;
		case 'w': w_level = 1;	break;
                case 'h':
                default:
                        (void)fprintf(stderr, "%s", Usage);
                        exit(1);
                        break;
                }

        argv += optind;
        argc -= optind;


	/* connect to host and get the binary dump */
	rc = get_route(rcp_host, port_number, w_level); 
	if (rc == NO_RCP_CONNECTION) {
		printf("!!! Can't talk to %s\n", rcp_host);
		printf("!!! Quit the program\n");
		exit(1);
	}

	if (rc == BAD_RCP_DATA) {
		printf("!!! Unaligned data from binary dump\n");
		printf("!!! Quit the program\n");
		exit(1);
	}
	exit(0);
}
