
/* 
 * bitcount: count 1 bits in n 
 * left shift is more efficient for ip mask
 * (1 bits are positioned on higher bits)
 */
int
mask_len(n)
	unsigned long	n;
{
	int	b = 0;
	
	for (b = 0; n != 0; n <<= 1)
		if (n & 0x80000000) b++;

	return b;
}


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/*
 * remove unnecessary trailing 0's from 
 * an IP network #.
 */
char *
trim_zero(sin_addr, len) 
	struct in_addr	*sin_addr;
	int	len;	/* mask length */
{
	static char	zero[2] = "0";
	static char	*ptr;

	/* special case: 0.0.0.0 - 0.0.0.0 */
	if ((sin_addr->s_addr == 0) && (len == 0)) 
		return zero; 

	/* first shift off unnecessary bytes */
/*
	(sin_addr->s_addr) >>= (32 - len);
*/

	(sin_addr->s_addr) >>= (((32 - len)/8)*8);

	/* drop leading 0's */
	ptr = inet_ntoa(sin_addr);
	while ((*ptr == '0') || (*ptr == '.'))
		ptr++;

	return ptr;
}
	